class BruchRechnung {

	static void init(Bruch bruch, int z, int n) {
		bruch.zaehler = z;
		bruch.nenner = n;
		kuerzen(bruch);
	}

	static void multTo(Bruch b1, Bruch b2) {
		b1.zaehler *= b2.zaehler;
		b1.nenner *= b2.nenner;
		kuerzen(b1);
	}

	static void addTo(Bruch b1, Bruch b2) {
		b1.zaehler = b2.nenner * b1.zaehler + b1.nenner * b2.zaehler;
		b1.nenner = b1.nenner * b2.nenner;
		kuerzen(b1);
	}

	static String toString(Bruch b) {
		return b.zaehler + "/" + b.nenner;
	}

	static void kuerzen(Bruch b) {
		int ggt = ggT(b.zaehler, b.nenner);
		b.zaehler /= ggt;
		b.nenner /= ggt;
	}

	static int ggT(int z1, int z2) {
		if (z2 == 0) {
			return z1;
		} else {
			return ggT(z2, z1 % z2);
		}
	}

	public static void main(String[] args) {
		int zaehler = IO.readInt("Bruch 1 (Zaehler): ");
		int nenner = IO.readInt("Bruch 1 (Nenner): ");
		Bruch b1 = new Bruch();
		init(b1, zaehler, nenner);
		IO.println("Bruch 1: " + toString(b1));

		zaehler = IO.readInt("Bruch 2 (Zaehler): ");
		nenner = IO.readInt("Bruch 2 (Nenner): ");
		Bruch b2 = new Bruch();
		init(b2, zaehler, nenner);
		IO.println("Bruch 2: " + toString(b2));

		multTo(b1, b2);
		IO.println("Bruch 1: " + toString(b1));
		IO.println("Bruch 2: " + toString(b2));

		addTo(b1, b2);
		IO.println("Bruch 1: " + toString(b1));
		IO.println("Bruch 2: " + toString(b2));
	}
}
