class Position {
	int zeile;
	int spalte;
}

class SchiebeSpiel {
	public static void main(String[] args) {
		int[][] matrix = { { 2, 14, 5, 7 }, { 3, 4, 15, 13 }, { 6, 1, 12, 11 },
				{ 3, 8, 9, 0 } };
		print(matrix);
		while (!korrekt(matrix)) {
			Position position = posEingabe(matrix);
			verschieben(matrix, position);
			print(matrix);
		}
	}

	static void print(int[][] matrix) {
		for (int i = 0; i < matrix.length; i++) {
			for (int j = 0; j < matrix[i].length; j++) {
				if (matrix[i][j] <= 10)
					IO.print(" ");
				IO.print(matrix[i][j] + " ");
			}
			IO.println();
		}
		IO.println();
	}

	static boolean korrekt(int[][] matrix) {
		int vgl = 0;
		for (int i = 0; i < matrix.length; i++) {
			for (int j = 0; j < matrix[i].length; j++) {
				if (vgl != matrix[i][j])
					return false;
				vgl++;
			}
		}
		return true;
	}

	static Position posEingabe(int[][] matrix) {
		// Achtung: erwartet eine korrekte Eingabe!
		Position pos = new Position();
		pos.zeile = IO.readInt("korrekte Zeile eingeben: ");
		pos.spalte = IO.readInt("korrekte Spalte eingeben: ");
		return pos;
	}

	static void verschieben(int[][] m, Position pos) {
		Position frei = freiesFeld(m);
		m[frei.zeile][frei.spalte] = m[pos.zeile][pos.spalte];
		m[pos.zeile][pos.spalte] = 0;
	}

	static Position freiesFeld(int[][] matrix) {
		for (int i = 0; i < matrix.length; i++) {
			for (int j = 0; j < matrix[i].length; j++) {
				if (matrix[i][j] == 0) {
					Position pos = new Position();
					pos.zeile = i;
					pos.spalte = j;
					return pos;
				}
			}
		}
		return null; // sollte eigentlich nicht vorkommen!
	}
} // end class
